#!/bin/bash
#
# Egyszeru script tobb Tomcat kezelesere.
# A mimoza-tomcat csomag resze.

DEFAULT="/etc/default"
EXIT_ERR=1
INIT="/etc/init.d"
SLEEPTIME="1"
TOMCAT="tomcat5.5"
TOMCAT_LIST=`ls -1 $DEFAULT/$TOMCAT.* 2>/dev/null | sed "s/^.*\/\(.*\)$/\1/"`
USAGE="Usage: $0 [-a | --all | -l | --list | instance_name] command(s)"

# Opcionalis kapcsolo felvetele

option=`echo $1 | sed -n "s/^-\+//p"`; if [ ! -z "$option" ]; then shift; fi

# A "list" opcio kiirja a vezerelheto tomcat-ek listajat, es kilep.

if [ "$option" = "l" -o "$option" = "list" ]; then
    echo "$TOMCAT_LIST" | sed "s/^$TOMCAT\.//"
    exit 0
fi

# Ha nincs "all" opcio, akkor az elso parameter a vezerlendo Tomcat neve.
# Ellenorizni kell, hogy ez szerepel-e a letezo Tomcate-ek listajaban.

if [ ! "$option" = "a" -a ! "$option" = "all" ]; then

    current_tomcat=$1; shift
    if [ -z "`echo "$TOMCAT_LIST" | sed -n "s/^$TOMCAT\.$current_tomcat$/X/p"`" ]; then
	echo -e "$USAGE\n"
	exit $EXIT_ERR
    else
	TOMCAT_LIST=$TOMCAT.$current_tomcat
    fi
fi

# A listaban szereplo Tomcat-eknek kiadja a parancsot.

for current_tomcat in $TOMCAT_LIST
do
    cp --preserve $DEFAULT/$current_tomcat $DEFAULT/$TOMCAT
    $INIT/$TOMCAT $*
    sleep $SLEEPTIME
done
