#!/bin/bash
# Very simple script to clone a (Mimoza) tomcat into a new instance. 
# Without any check and error handling - use carefully! 

EXIT_ERR=1
TOMCAT_DEFAULT="system"

MSG_USAGE="Very simple script to clone a (Mimoza) tomcat into a new instance.\nUsage: $0 new_tomcat_name [tomcat_name_to_clone]\n"

# New tomcat name is mandatory
TOMCAT_NAME=$1; shift
if [ -z "$TOMCAT_NAME" ]; then echo -ne "$MSG_USAGE"; exit $EXIT_ERR; fi

# Template name is optional
TOMCAT_TEMPLATE=${1:-$TOMCAT_DEFAULT}

MSG_FINISH="Edit /etc/tomcat4/conf.d/$TOMCAT_NAME/conf/server.xml before starting!\nCheck webapps also.\n"
MSG_START="Template:   $TOMCAT_TEMPLATE\nNew tomcat: $TOMCAT_NAME\nWithout any check and error handling - use carefully!\nPress CTRL-C in doubt, ENTER to continue.\n"

# Warning, maybe dangerous...
echo -ne "$MSG_START"; read dummy

# Cloning

mkdir -m 755 /etc/tomcat5.5/conf.d/$TOMCAT_NAME
cp -rL --preserve /etc/tomcat5.5/conf.d/$TOMCAT_TEMPLATE/conf /etc/tomcat5.5/conf.d/$TOMCAT_NAME

mkdir -m 750 /var/log/tomcat5.5/$TOMCAT_NAME; chown webadmin:root /var/log/tomcat5.5/$TOMCAT_NAME
ln -s /var/log/tomcat5.5/$TOMCAT_NAME /etc/tomcat5.5/conf.d/$TOMCAT_NAME/logs

ln -s /var/lib/tomcat5.5/shared /etc/tomcat5.5/conf.d/$TOMCAT_NAME/shared

mkdir -m 755 /var/lib/tomcat5.5/temp/$TOMCAT_NAME; chown webadmin:root /var/lib/tomcat5.5/temp/$TOMCAT_NAME
ln -s /var/lib/tomcat5.5/temp/$TOMCAT_NAME /etc/tomcat5.5/conf.d/$TOMCAT_NAME/temp

mkdir -m 755 /var/lib/tomcat5.5/webapps/$TOMCAT_NAME; chown webadmin:root /var/lib/tomcat5.5/webapps/$TOMCAT_NAME
cp -rL --preserve /var/lib/tomcat5.5/webapps/$TOMCAT_TEMPLATE/* /var/lib/tomcat5.5/webapps/$TOMCAT_NAME/
ln -s /var/lib/tomcat5.5/webapps/$TOMCAT_NAME /etc/tomcat5.5/conf.d/$TOMCAT_NAME/webapps

mkdir -m 755 /var/cache/tomcat5.5/$TOMCAT_NAME; chown webadmin:webadmin /var/cache/tomcat5.5/$TOMCAT_NAME
cp -rL --preserve /var/cache/tomcat5.5/$TOMCAT_TEMPLATE/* /var/cache/tomcat5.5/$TOMCAT_NAME/
ln -s /var/cache/tomcat5.5/$TOMCAT_NAME /etc/tomcat5.5/conf.d/$TOMCAT_NAME/work

cat /etc/default/tomcat5.5.$TOMCAT_TEMPLATE | sed "s/$TOMCAT_TEMPLATE/$TOMCAT_NAME/g" >/etc/default/tomcat5.5.$TOMCAT_NAME

# Finished
echo -ne "$MSG_FINISH"
